#!/bin/sh
#chrono.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: play_chrono.tcl,v 1.9 2006/03/25 00:55:15 abuledu_francois Exp $
#  Author  : andre.connes@wanadoo.fr
#  Date    : 05/01/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************
global file flag
source chrono.conf
source msg.tcl
source fin_sequence.tcl
source eval.tcl
source lanceapplication.tcl
set file [lindex $argv 0]
set flag 0

  #
  # langue par defaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]
##################################################################################
  # charger la liste (triee) des images
  set glob(dossier) ""
  set glob(images_toutes) ""

  # selectionner dans cette liste les images traitees
  set glob(images_selectionnees) ""
 ##################################################################################"  
# Decommenter la ligne suivante si Img est installe
 package require Img

######################################
#
# compte_rendu
#
# - afficher le travail ecrit de l'eleve
#



####################################################
#
# sauvegarde : appele quand quitter ou fin du theme
#
# - glob(trace_dir) est le chemin des traces (log) relativement a l'eleve
# - glob(trace_user) est le chemin de sauvegarde suivi du nom de l'eleve
# - glob(theme) est l'extension du nom du fichier de sauvegarde
# - sauvegarde de glob(theme_texte)
#
####################################################

####################################################
#
# image_suivante
#
####################################################

proc image_suivante { } {
  global glob can_img can_zones
  # desactiver le pouce
  #.bframe.but_pouce configure -state disabled
  # sauvegarder les donnees de l'image actuelle avant de passer a la suivante
  append glob(theme_texte) "$glob(image_texte)\n"
  # image suivante
  set glob(nimage) [expr $glob(nimage) +1]
  main $can_img $can_zones
} ;# image_suivante

####################################################
#
# ok_zone
#
####################################################

proc ok_zone { } {
    global glob can_img can_zones
  
    #set zone_texte [.top_zone.text_zone get 0.0 end]
    # sauvegarder cette zone_texte
    #append glob(zone_texte) "- zone $glob(nzone) : \n $zone_texte"
    #append glob(brut_texte) "---\n$zone_texte"
    # passer au numero de zone suivant
    #set ligne [string range $zone_texte 0 30]
    set sysFont {Helvetica 15 bold} ;# {Geneva 15 bold}{Adobe-Courier 15 bold}
    # numero du carre-zone
    ##$can_zones create text 30 [expr 25*$glob(nzone)-10]  \
      -fill red -font $sysFont -text "$glob(nzone). " ;# -tag nzone_$glob(nzone)
    # entree des mots-cles de la zone
    ##$can_zones create text 50 [expr 25*$glob(nzone)] \
      -fill black -font $sysFont -anchor w -text "$ligne" ;# -tag tzone_$glob(nzone) 
    #destroy .top_zone

    zone_suivante
    
} ;#ok_zone

####################################################
#
# selectionner_rect
#
####################################################

proc selectionner_rect { can_img } {
  global list_rect
  
  foreach nrect $list_rect {
    set i [lindex $nrect 0]
    set j [lindex $nrect 1]
    $can_img bind rect($i,$j) <Enter> ""
    $can_img delete rect($i,$j)
  }

  # saisir le texte de cette zone
  ##destroy .top_zone
.bframe.but_pouce configure -state normal

} ;# selectionner_rect

####################################################
#
# decouvrir_image
#
####################################################

proc decouvrir_image { } {
  global glob can_img

    # montrer toute l'image
    for { set i 0 } { $i < $glob(nbrow) } { incr i 1 } {
      for { set j 0 } { $j < $glob(nbcol) } { incr j 1 } {
        $can_img delete rect($i,$j)
      } 
    }
  if { $glob(nimage) >= [llength $glob(images_selectionnees)] } {
    .bframe.but_pouce configure -state disabled
    #.bframe.but_win configure -state normal    
  } else {
    .bframe.but_pouce configure -state normal
    .bframe.but_oeil configure -state disabled
  }  
}

####################################################
#
# zone_suivante
#
####################################################

proc zone_suivante { } {
  global can_img can_zones glob list_rect cadre rect bgimage v_width v_height
  set glob(nzone) [expr $glob(nzone) +1]
  # si plus de zone pour cette image
  if { $glob(nzone) > $glob(nzone_total) } {
    #sauvegarder zone_texte dans image_texte
    #append glob(image_texte) $glob(zone_texte)
	.bframe.but_pouce configure -state disabled
    .bframe.but_oeil configure -state normal
#    tk_messageBox -default ok -message " [mc image_suivante]" -parent .
#    image_suivante
  }
#tk_messageBox -message "$glob(list_zones) aa $glob(nzone)"
  set list_rect [lrange [lindex $glob(list_zones) $glob(nzone)] 1 end]
#tk_messageBox -message $list_rect
  # on fait apparaitre la zone
  foreach nrect $list_rect {
    set i [lindex $nrect 0]
    set j [lindex $nrect 1]
    $can_img create rect [expr $glob(org) + $j*($v_width) +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width -10] [expr $glob(org) + ($i+1)*$v_height -10] \
	  -fill $glob(bgcolor) -width 0 -tag rect($i,$j)
#$can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -fill $glob(bgcolor) -width 1 -tag rect($i,$j) 
 
    $can_img bind rect($i,$j) <Enter> "selectionner_rect $can_img"
  }
.bframe.but_pouce configure -state disabled

} ;# zone_suivante

# #################################################################################
#
#                                   main
#
# #################################################################################
proc clicmotion {can_img i j} {
global flag
variable toggleflag
if {$flag==1 && $toggleflag == 1} {
$can_img bind rect($i,$j) <Enter> \"\" ;$can_img delete rect($i,$j)
}
}

proc main { can_img can_zones } {
  global glob bgimg bgimage v_height v_width listeval file flag
  $can_img delete all
  $can_zones delete all
  
  # afficher le fond, fonction de l'image
  # de la liste des images sélectionnées

  set bgimg $file
  
  set bgimage [image create photo -file [file join images $bgimg]]

  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  $can_img create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage -tag imgfond

  # lire les caracteristiques de cette image : nb.lignes/colonnes + zones
  set nom_image [file rootname [file tail $bgimg]]
  set glob(list_zones) ""
  catch {  
   set f [open [file join [pwd] zones $nom_image] "r"] 
  [set glob(list_zones) [gets $f] ]
  close $f
  }
if { $glob(list_zones) ==""} {
tk_messageBox -message "Aucune zone dtecte dans l'image"
return
}
  # initialiser la sauvegarde du texte frappe par l'eleve pour chaque image
  set glob(image_texte) "\nNom de l'image n° [expr $glob(nimage) +1] : $nom_image\n"
  # determiner le nombre de lignes et de colonnes de l'image actuelle
  set nb [lindex $glob(list_zones) 0]
  set glob(nbrow) [lindex $nb 0]
  set glob(nbcol) [lindex $nb 1]

  set v_height [expr ($hbgimage + $glob(nbrow)) / $glob(nbrow)]
  set v_width [expr ($wbgimage + $glob(nbcol)) / $glob(nbcol)]

  ####################Creation du tableau###################################
  # On utilise des rectangles pour dessiner les cases

    # on cache tout
    for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -fill $glob(bgcolor) -width 0 -tag rect($i,$j)

     $can_img bind rect($i,$j) <Motion> "clicmotion $can_img $i $j"


      }
    }


    # on encadre toutes les zones
      $can_img create rect [expr $glob(org) ] [expr $glob(org) ] \
	  [expr $glob(org) + $wbgimage] [expr $glob(org) + $hbgimage] \
	  -width 2


  # determiner le nombre de zones a devoiler
  set glob(nzone_total) [expr [llength $glob(list_zones)] -1]
  # initialiser le numero de zone a devoiler (0 au depart. La premiere sera 1)
  set glob(nzone) 0
  # initialiser la sauvegarde du texte total frappe par l'eleve
  set glob(zone_texte) ""
  # c'est parti !
    bind $can_img <ButtonPress-1> "global flag; set flag 1"
     $can_img bind imgfond <ButtonRelease-1> "global flag; set flag 0"

  zone_suivante

} ;# main

#####################################################################################
#
# fenetre principale
#
#      placement de la fenetre en haut et a gauche de l'ecran
#
#####################################################################################
#wm resizable . 0 0
#wm geometry . [expr [winfo screenwidth .]-10]x[expr [winfo screenheight .]-80]+0+0
. configure -bg $glob(bgcolor)
wm geometry . 795x580+0+0
. configure -bg $glob(bgcolor)

frame .frame -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

  # lire le nom du theme
  set glob(theme) ""

  # intialiser la sauvegarde totale du texte frappe par l'eleve pour ce theme
  set glob(theme_texte) "Le thème : $glob(theme)\n----------\n"
  set glob(brut_texte) ""
  wm title . "[mc $glob(theme)]"

# ################ On cree un canvas image ###########################################
# a gauche

set can_img .frame.c
canvas $can_img -width 794 -height 496 -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_img -side left -expand true 

# ####################################################################################
# une frame a droite de ce canvas

set f .frame.d 
frame $f -bg $glob(bgcolor)
pack $f -side left -expand true

# ################ On y cree un canvas parametres ####################################

#set can_parametres $f.d
#canvas $can_parametres -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
#pack $can_parametres -side top -expand true 

# ############## On y cree un canvas pour numeros et descriptions de zones ###########
set can_zones $f.e
canvas $can_zones -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_zones -side top -expand true    
  
# ############# on cree une frame oeil, pouce, gagne, porte ##########################
# en bas

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true

    button .bframe.but_oeil -image \
      [image create photo foeil \
      -file [file join sysdata oeil.png]] \
      -state disabled \
	-bg $glob(bgcolor) \
      -command "decouvrir_image"
    grid .bframe.but_oeil -padx 10 -column 0 -row 1

  button .bframe.but_pouce -image \
    [image create photo fpouce \
    -file [file join sysdata pouce.png]] \
    -bg $glob(bgcolor) \
    -command "ok_zone"
  grid .bframe.but_pouce -padx 10 -column 1 -row 1

    checkbutton .bframe.but_win -image \
      [image create photo fwin \
      -file [file join sysdata quidonc.png]] \
      -variable toggleflag \
	-bg $glob(bgcolor) \
	-command "global flag; set flag 0"
    grid .bframe.but_win -padx 10 -column 2 -row 1

  button .bframe.but_quitter -image \
    [image create photo fquitter \
    -file [file join sysdata quitter_minus.png]] \
    -command "lanceappli chrono.tcl"
  grid .bframe.but_quitter -padx 10 -column 3 -row 1

  set glob(nimage) 0
  
main $can_img $can_zones
